      program check_giv_header
C find shitty headers in rvp8 data

	character*36 directory
	integer lu, lu_errors
	integer*4 chk_flags

	character*80 ps_file
      character cmd*1
	character create_time*32
	character yesno*1, cstr*60
C
	character time_string*4, out_fn*80
	character*2 tape_string
C Radar tape/file stuff
	include "hrd_radar_common_blocks.f"

	character*80 radar_fn
      REAL SECONDS,time_start,time_end,TIME1,TIME2,
     +     AZMCOR,ELCOR,PCOR,RCOR,DCOR
	logical found_tail, want_port
 	integer*4 maxpts, badz
	integer*4 taplu, irdwr, tape, outlu, ierr, method
	character*32 time_stamp ! for writing out current time
	logical exist
C
	pi = acos(-1.0)
	pi180 = pi / 180. 
C
C
C get tape, and  output file
C  From Nancy Griffin's documentation

	kindradar = 2

	lu = 10
	iout_lu = 21

	write(6,*)'enter sweep directry'
	read(5,'(a)')directory
	call open_rvp8_file(directory, lu, lu_errors, ierr)

	IHEADERFLAG=0 !DON'T WANT BIG HEADER INFO
	IDATAFLAG = 6   ! DBZ ARRAY (BIT 2= ON), vel array bit1 = on.

	call getarg(2,time_string)
	if(time_string .eq. ' ') then
	  write(6,*)' Enter start time (hhmm) '
	  read(5,'(2i2)')ihs,ims
	else
	  read(time_string(1:4), '(2i2)')ihs,ims
	end if
	call getarg(3, time_string)
	if(time_string .eq. ' ') then
	  write(6,*)' Enter end time (hhmm) '
	  read(5,'(2i2)')ihe,ime
	else
	  read(time_string(1:4), '(2i2)')ihe, ime
	end if
	iss = 0
	ise = 0
	call getarg(4, out_fn)
	if(out_fn .eq. ' ') then
		out_fn = 'Bad_extended_hdrs.txt'
	end if
	open(iout_lu, file=out_fn,form='formatted')
	write(iout_lu,"('Searched ',3i2.2,1x,3i2.2)")ihs,ims,iss,i
     +     he,ime,ise
	write(6,*)'ray,time,lat,lin.alt,ws,wd'
	time_start = 3600.0 * ihs + 60.0 * ims + iss
	time_end = 3600.0 * ihe + 60.0 * ime + ise
	if (time_end .lt. time_start) time_end = time_end + 24.0 *3600.0
C
C space to start time:
	iswp1 = -1
	time = -1.0
	iop = 2 ! 1-> search by sweep number, 2-> search by time
	rkey = time_start
	call rvp8_search(lu,kindradar,iop,rkey,ierr)
c

	n_smpl = 0
C chec for jumps and bad winds
C read a ray to prime the traps
	  call radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,
     +		IDATAFLAG, IERR)
C following did not work because there are no missing data flags for
C angles. ke garne.
Cout	call check_hrd_blocks(chk_flags)
cout	if(chk_flags .ne. 0) then
cout	  call print_hrd_blocks(iout_lu, chk_flags)
cout	end if

	prev_lat = rlat
	PREV_LON = rlon
	prev_wd = wd
	prev_ws = ws
	prev_time = time
C ray to ray should noi jump more than
C 1 km which is approc 0.01 eeg... unless there
C is a time jump also...
	dtime_max = 6.0 ! seconds at 10 rpm
	dlat_max = 0.02 ! 2 km
	dlon_max = dlat_max
	dwd_max = 5 !degrees
	dws_max = 5  ! m/s
	n_good = 0
	n_bad = 0

	do while( time .lt. time_end)
	  call radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,
     +		IDATAFLAG, IERR)



	  if(ierr .lt. 0) then
	   if( ierr .gt. -2 ) then
		write(6,*) ' taperead error ',ierr,' will try next.'
C ierr = -4 does not mean eof or "eot" but 
C is caused by bad sweep file names and in
C incomplete files
	   else if(ierr .gt. -4) then
		write(6,*)ierr, ' eot.'
		go to 1000
	   end if
	  end if
	call check_hrd_blocks(chk_flags)
	if(chk_flags .ne. 0) then
	  call print_hrd_blocks(iout_lu, chk_flags)
	end if

	  n_smpl = n_smpl + 1
	   ihdr_flag = 0
	   dlat = abs(rlat-prev_lat)
	   dlon = abs(rlon-prev_lon)
	   dws = abs(ws - prev_ws)
	   dtime = abs(prev_time - time)

	   if(dlat .gt. dlat_max)then
		ihdr_flag = ihdr_flag + 1
	   end if

	   if(dlon .gt. dlon_max)then
		ihdr_flag = ihdr_flag + 2
	   end if

	   if(dws .gt. dws_max)then
		ihdr_flag = ihdr_flag + 4
	   end if

	   if(chk_flags .ne. 0) then
		n_bad = n_bad + 1
	   else if(ihdr_flag .ne. 0) then
		n_bad = n_bad + 1
		write(iout_lu, 444)n_smpl,ih,im,is,is100,
     +		   rlat,rlon,  ra, ws, wd
444	format(i8,1x,3i2.2,".",i2.2,2(1x,f7.2),1x,f8.2,2(1x,f6.2) )
		write(iout_lu,445)'lat, prev lat:',rlat,prev_lat
		write(iout_lu,445)'lon, prev lon:',rlon,prev_lon
		write(iout_lu,445)' ws, prev  ws:',ws,prev_ws
		write(iout_lu,*)'    del time: ',dtime

445	format(6x,a13,2(1x,f7.2))
		write(iout_lu,*)'Full TDR header: '
		call print_TDR_header(iout_lu)
		write(iout_lu,*)' end TDR header'
	    else
		n_good = n_good + 1
	   end if

	   prev_lat = rlat
	   prev_lon = rlon
	   prev_ws = ws
	   prev_wd = wd
	   prev_time = time
C add check for greound speed
C nut nor really sure what would be a bad val!
	   if(gs  .gt. 400.0) then
		write(iout_lu,1221)gs,gse,gsn,vgs
1221	format('Bad gs spd: ',4(1x,f6.1))
	   end if	
	end do
C 
C
C


1000	write(6,*)'num good, bad headers: ', n_good, n_bad
	end
