	program crap_from_dump
C read the az_dump files created by rays_dump
C and accum some stats on beam withs and gaps between 
C rays
	implicit none

	integer i, ii
	real gap, prev_az_end
	real gap_avg(360)
	real gap_min(360), gap_max(360)
	integer num_non_zero(360)
	integer num_zero(360)
	character*80 list_fn,dump_fn,sweep_fn
	integer list_lu
	integer num_bins
	integer time_since_sweep_start
	real az_beg, az_end, del_az
	real dbz_max,dbz_max_2
	integer ipos_max
	integer  irs_age, gps_age
C
	integer num_times_first(360)
	integer first_ray
	real first_start
C
	list_lu = 10
c
	do i = 1,360
	  num_times_first(i)=0
	  gap_avg(i) = 0.0
	  gap_min(i) = 999.0
	  gap_max(i) = -999.0
	  num_zero(i) = 0
	  num_non_zero(i) = 0
	end do
C
	call getarg(1, list_fn)
	if(list_fn(1:1) .eq. ' ')then
	  write(6,*)'files list?'
	  read(5,'(a)')list_fn
	end if
	open(list_lu,file=list_fn,form='formatted')

10	read(list_lu,'(A)',end=200, err=200)dump_fn
	open(33,file=dump_fn,form='formatted')
	write(6,*)'opened ',dump_fn
	read(33,778)sweep_fn
778	format(12x, a)
	first_ray = -1
	first_start = 32767
	do ii = 1, 3
	  read(33,*)
	end do
C read first to perhps prime pump
	read(33,636)i, num_bins,
     +		time_since_sweep_start,
     +		az_beg, az_end, del_az,dbz_max,
     +		dbz_max_2, ipos_max,
     +		irs_age, gps_age
	if(num_bins .gt. 0) then
	   if(time_since_sweep_start .lt. first_start)then
		first_ray = i
		first_start = time_since_sweep_start
	   end if
	   if(az_beg .lt. 0)az_beg = az_beg + 360.0
	   if(az_end .lt. 0)az_end = az_end + 360.0
	   prev_az_end = az_end
	   num_non_zero(1)=num_non_zero(1) + 1
C following is a kludge because of circular crap...
	   gap_avg(1) = gap_avg(1) + az_beg
	   if(az_beg .lt. gap_min(1))gap_min(1)=az_beg
	   if(az_beg.gt.gap_max(1))gap_max(1)=az_beg
	else
		num_zero(1) = num_zero(1) + 1
		prev_az_end = -999.9
	end if
	do ii = 2, 360
	read(33,636)i, num_bins,
     +		time_since_sweep_start,
     +		az_beg, az_end, del_az,dbz_max,
     +		dbz_max_2, ipos_max,
     +		irs_age, gps_age
C from rays_dump.f:
636	format(i4,1x,i4,1x,i5,2(1x,f6.1),1x,f7.2,2(1x,f5.1),1x,i4,
     +    2(1x,i6))
	if(num_bins.gt.0)then
	 if(time_since_sweep_start .lt. first_start)then
		first_ray = i
		first_start = time_since_sweep_start
	 end if
	end if
	if(az_beg.lt.0.0)then
	   az_beg = az_beg + 360.0
	end if
	if(az_end .lt. 0.0) then
	   az_end = az_end + 360.0
	end if
C i had set i negative for rays with 0 bins.`z
	if(i .lt. 0) i = -i
c
	if(num_bins .gt. 0) then
	 if(prev_az_end .gt. -999.0)then
	 gap = abs(az_beg  - prev_az_end)
	 prev_az_end = az_end
	 num_non_zero(i) = num_non_zero(i) + 1
	 gap_avg(i) = gap_avg(i) + gap
	 if(gap.lt.gap_min(i)) gap_min(i) = gap
	 if(gap.gt.gap_max(i))gap_max(i) = gap
	 else
	   prev_az_end = az_end
	 end if
	else
	  num_zero(i) = num_zero(i) + 1
	end if
C
	end do
100	close(33)
	if(first_ray .gt. 0) then
	  num_times_first(first_ray) = num_times_first(first_ray) + 1
	end if
		go to 10
200	close(list_lu)
C	
	do i = 1, 360
	  if(num_non_zero(i) .gt. 0)then
		gap_avg(i)=gap_avg(i)/num_non_zero(i)
	  end if
	end do
C
	do i = 1, 360
	  write(22,123)i,gap_avg(i),gap_min(i),gap_max(i),
     +	    num_non_zero(i),num_zero(i),num_times_first(i)
123	  format(i3,3(1x,f7.2),2(1x,i5) , 1x,i5)
	end do
C
	end
