	Program rdsweep_to_so
	implicit none
        include "hrd_radar_settings.f"
	integer, parameter:: iclose=25          ! raw data number closed to SO and picked up to produce SO
	integer :: so_num, so_number, nr, na, nmax, so_num_2, so_num_max
	real :: r_dis, alpha, dda, ddr,hgt
c        real, dimension(100000) :: so_range, so_azimuth,so_dr,so_da
	real, allocatable, dimension(:) :: so_range, so_azimuth, 
     1                                     so_dr, so_da 
        real, allocatable, dimension(:) :: heighttest
        integer, allocatable, dimension(:) :: iheighttest
        real so_rangen,so_azimuthn,so_drn,so_dan,height
	real, allocatable, dimension(:,:):: so_vr
	real, allocatable, dimension(:)  :: raw_num_bin
	real, allocatable, dimension(:,:,:):: raw_data_bin
c	real, dimension(5000,9):: so_vr
c	real, dimension(5000)  :: raw_num_bin
c	real, dimension(5000,500,9):: raw_data_bin
        integer igaterun, hours48
	integer :: nbin
        real igatesum
	real :: mean, stdm, dvr, stdm_mean, x, y, dis
	real, dimension(iclose,9) :: close_rv
	real, dimension(iclose) :: close_dis
	integer :: mm, second, minute, hour, day, month, year
	character(len=14) :: swpfilename
	integer :: isecond, iforback, iost, iyear, imonth, 
     1             iday, maxi, igate
	integer :: i, j, n, min_num, num_all, num_1, num_9
	real :: min_elv, r, alpha1, d1, d2, d3, d4                   
	real, dimension(max_hrd_dim) :: radius 
	real, dimension(6200) :: timerad, rrlat, rrlon, rra, eazm, 
     1                            eev, theta, rtrackmult
	real, dimension(400000) :: rtrack
	real, dimension(6200,max_hrd_dim) :: temp   !(360/0.8d)*(60/0.15km)
	real, dimension(400000, 9) :: rawvr  ! 1-9: timerad, rrlat, rrlon, rra, eazm, eev, radius, rv, theta
	real, dimension(400000, 9) :: vr_9   ! 1-9: timerad, rrlat, rrlon, rra, eazm, eev, radius, rv, theta
	real, allocatable, dimension(:)     :: scatter
	common /one/temp,rawvr,vr_9
	integer, allocatable, dimension(:)  :: iscatter
	integer                             :: index,index10
	integer            :: namelist_unit
	real               :: elevmax
	real :: mindis, maxdis, ddis, dazm, stdrv, 
     1          threshold_r, threshold_a
	real               :: minrv, maxrv
	integer :: start_year, start_month, start_day, start_hour, 
     1     start_minute, start_second
	integer            :: minutes
	namelist /so_attribute/   elevmax, mindis, maxdis, ddis, 
     1   dazm, stdrv, threshold_r, threshold_a, minrv, maxrv
	namelist /so_time/ start_year, start_month, start_day, 
     1     start_hour, start_minute, start_second, minutes
C------------------------------------------------------------
C.. get namelist.so
	  namelist_unit = 9
          write(6,*)'i got here one'
c          open(86,file='/dev/tty')
	  open ( file = 'namelist.so', unit = namelist_unit,
     1	         status = 'old', access = 'sequential', iostat = iost )
	  read ( unit = namelist_unit, nml =   so_attribute, 
     1           iostat = iost )
	  read ( unit = namelist_unit, nml =   so_time     , 
     1           iostat = iost )
	  close ( unit = namelist_unit )
C==============================================================================
C define SO's bin 
        nmax=0
        so_num_max=0
	so_num = 0
	nr = int( (maxdis - mindis) / ddis ) + 1
	do_radial_range_loop  : do j = 1, nr
C....define radial position
	   r_dis = mindis + ddis*(float(j) - 0.5)
C....calculate bin's azimuth range
	   alpha = threshold_a - (threshold_a-dazm)/(nr-1)*(j-1)
c           write(6,*)'threshold_a,dazm,alpha before,j,nr = ',
c     1                threshold_a,dazm,alpha,j,nr
	   alpha = min(alpha, 89.)
           write(6,*)'alpha after,j,nr = ',alpha,j,nr
	   na = int( 360. / alpha )

	   do_azimuth_loop : do i = 1, na
	      so_num = so_num + 1
	      so_rangen=r_dis
	      so_azimuthn=0.+alpha*float(i-1)
              so_drn=ddis/2.
              so_dan=alpha/2.
              height=cos(so_azimuthn*3.14159/180.)*r_dis
              write(6,*)'n,r,theta,height = ',so_num,n,r_dis,so_azimuthn,height
              if(height.gt.25..or.height.lt.-10.)so_num = so_num -1
	   end do do_azimuth_loop
	end do do_radial_range_loop
        so_num_2=so_num/2
c        allocate( heighttest (so_num) )
c        allocate( iheighttest (so_num) )
        so_number=so_num+10
	allocate( so_range (so_number) ) 
	allocate( so_azimuth (so_number) ) 
	allocate( so_dr (so_number) ) 
	allocate( so_da (so_number) ) 
	allocate( so_vr (so_number,9))    !1-9: timerad, rrlat, rrlon, rra, eazm, eev, radius, rv, theta
	allocate( raw_num_bin(so_number) )
	allocate( raw_data_bin(so_number,4000,9))    !1-9: timerad, rrlat, rrlon, rra, eazm, eev, radius, rv, theta
	                                         !500: max number in all bins
	n = 0
c        write(6,*)'one'
	do j = 1, nr
	   r_dis = mindis + ddis*(float(j) - 0.5)
	   alpha = threshold_a - (threshold_a-dazm)/(nr-1)*(j-1)
	   alpha = min(alpha, 89.)
	   na = int( 360. / alpha )
	   do i = 1, na
	      n = n + 1
	      so_range(n) = r_dis
	      so_azimuth(n) = 0. + alpha * float(i-1)
	      so_dr(n) = ddis/2.
	      so_da(n) = alpha/2.
              height=cos(so_azimuth(n)*3.14159/180.)*r_dis
              if(height.gt.25..or.height.lt.-10.)then
               n=n-1
              endif
c              write(6,*)'n,so_azimuth(n),r_dis,heighttest(n) ',
c     1          n,so_azimuth(n),r_dis,heighttest(n)
	   enddo
	enddo 
        write(6,*)'so_num,n = ',so_num,n
c        write(6,*)'two'
C==============================================================================
C Time loop , everry 1 min
	do_minutes_loop : do mm = 1, minutes
	    second = 0
	    minute = start_minute + mm - 1
	    hour   = start_hour
	    day    = start_day
	    month  = start_month
	    year   = start_year
	    call datetime(year, month, day, hour, minute, second,
     1                     hours48)
C==============================================================================
C read in sweep file in 1 min, calculate the angle between the zenith and the line
C   from airplane to data point (the angle ranges from 0 to 360); 
C and delete the usenessless data;
C save 1/10 random data; and kepp the other data in vr(1:8,450*450*5)  
	    do_forback_sweep_loop : do iforback = 1, 2
C------------------------------------------------------------------------------
	       j = 1
	       do_second_loop : do second = 0, 59
c                   write(6,*)'write second = ',second
C............open sweep file
                   write(6,'(6i2.2,a1,i1)')
     1               start_year-2000, start_month, start_day,
     1               hours48, minute,
     1               second, '_', iforback-1
	           write(swpfilename,'(6i2.2,a1,i1)')
     1               start_year-2000, start_month, start_day, 
     1               hours48, minute, 
     1               second, '_', iforback-1
                   write(6,*)year-2000,month,day,hour,minute,second
                   write(6,'(A14)')swpfilename
	           open(11, file='../'//swpfilename(1:6)/
     1               /'/'//swpfilename//'.swp', form = 'formatted', 
     1               status='old', iostat = iost )
	           if( iost > 0 ) cycle do_second_loop
	           write(*,*) swpfilename
C............get sweep data
	           read(11, '(3i2,x,i4)')iyear, imonth, iday, maxi
	           read(11, '(8f10.3)')(radius(i),i=1,maxi)
c                   write(6,*)'beginning do_get_vr_loop'
	           do_get_vr_loop : do
	              read(11, '(8f10.3)', iostat = iost )
     1                 timerad(j), rrlat(j), rrlon(j),   
     1                 rra(j), eazm(j), eev(j), (temp(j,i), i=1,maxi)
	              if( iost < 0 ) exit
	              j = j + 1
	                  if (j >= 450*6 ) write(*,*)'raw gates', j
	           end do do_get_vr_loop
c                   write(6,*)'ending do_get_vr_loop'
	           close(11)
	       end do do_second_loop
	       igate = j - 1
               write(6,*)'igate = ',igate
C------------------------------------------------------------------------------
C........calculate the angle between the zenith and the line from airplane to data point
C........search the bottom (min eev) point
	       min_elv = 0.
	       min_num = 0
	       do j = 1, igate
	          if( eev(j) < min_elv )then
	              min_elv = eev(j)
	              min_num = j
	          endif
	       enddo
               igaterun=igate
               if(igate.gt.30)igaterun=21
               igatesum=0
               do j=1,igaterun
	          alpha1=eazm(j)-eazm(min_num)
	          d1=r*cos(eev(j)/180.*3.1415926)
	          d2=d1*sin(alpha1/180.*3.1415926)
	          d3=d2
	          d4=r*sin(eev(j)/180.*3.1415926)
c	          theta(j)=atan(d3/d4)*180./3.1415926
                  theta(j)=atan2(d3,d4)*180./3.1415926
                  if(j.gt.11)igatesum=igatesum+theta(j)-theta(j-1)
                  if(j.gt.11)write(6,*)'igatesum,theta = ',
     1              igatesum,theta(j)
                enddo                  
               write(6,*)'igatesum = ',igatesum
C........claculate
	       r=radius(maxi)
	       do j = 1, igate 
C...........angle between the line from radar to obs and airplane
	          alpha1=eazm(j)-eazm(min_num)
C...........distance from radar to the circle that they intersect at right angles
c	          d1=r*cos(min_elv/180.*3.1415926)
	          d1=r*cos(eev(j)/180.*3.1415926)
	          d2=d1*sin(alpha1/180.*3.1415926)
	          d3=d2
	          d4=r*sin(eev(j)/180.*3.1415926)
c	          theta(j)=atan(d3/d4)*180./3.1415926
                  theta(j)=atan2(d3,d4)*180./3.1415926
                  rtrackmult(j)=sqrt(d3*d3+d4*d4)/r
c                  write(6,*)j,theta(j),rtrackmult(j)
c                  write(6,*)'j,min_elv,eazm_min_num,eev,eazm,alpha1,',
c     1  'r,d1,d2,d4,theta,radius,rtrackmult = ',
c     1  j,min_elv,eazm(min_num),eev(j),eazm(j),alpha1,r,d1,d2,d4,
c     1  theta(j),radius(j),rtrackmult(j)
c	          if( alpha1 >= 0. .and. eev(j) >= 0. ) then
c	              theta(j) = theta(j)
c	          else if ( alpha1 >= 0. .and. eev(j) < 0. ) then
c	              theta(j) = theta(j) + 180.
c	          else if ( alpha1 < 0. .and. eev(j) < 0. ) then
c	              theta(j) = theta(j) + 180.
c	          else if ( alpha1 < 0. .and. eev(j) > 0. ) then
c	              theta(j) = theta(j) + 360.
c	          endif
                  if(theta(j).lt.0.)theta(j)=theta(j)+360.
                  if(theta(j).gt.360.)theta(j)=theta(j)-360.
                  if(igatesum.lt.0.)theta(j)=360.-theta(j)
	       enddo
C------------------------------------------------------------------------------
C........delete the usenessless data
               write(6,*)'deleting the useless data'
	       n = 0
	       do j = 1, igate
	          do i = 1, maxi
	             if ( abs(temp(j,i)) >= 2. .and. 
     1                    abs(temp(j,i)) < maxrv .and. 
     1                    abs(eev(j)) < elevmax .and. radius(i) > 
     1                    mindis ) then
	                  n = n+1
	                  if (n >= 450*5*450 ) write(*,*)'raw obs', n
	                  rawvr(n,1) = timerad(j)
	                  rawvr(n,2) = rrlat(j)
	                  rawvr(n,3) = rrlon(j)
	                  rawvr(n,4) = rra(j)
	                  rawvr(n,5) = eazm(j)
	                  rawvr(n,6) = eev(j)
	                  rawvr(n,7) = radius(i)
	                  rawvr(n,8) = temp(j,i)
	                  rawvr(n,9) = theta(j)
                          rtrack(n) = radius(i)*rtrackmult(j)
c                       write(6,*)'j,n,timerad,theta,radius,rtrack = ',
c     1 j,n,timerad(j),theta(j),radius(i),rtrack(n)
                       hgt=cos(theta(j)*3.14159/180.)*rtrack(n)
c       if(hgt.gt.25..or.hgt.lt.-10)then
c      write(6,*)'i,j,n,eazm,eev,min_elv,theta,radius,rtrack = ',
c     1           i,j,n,eazm(j),eev(j),min_elv,theta(j),radius(i),
c     1           rtrack(n)
c      write(6,*)'i,j,n,rtrackmult(j),hgt = ',i,j,n,rtrackmult(j),hgt
c       endif
	             endif
	          enddo
	       enddo
	       num_all = n
               write(6,*)'finished deleting the useless data'
	       write(*,*)'raw obs', num_all 
C------------------------------------------------------------------------------
	       open(22, file='../'//swpfilename(1:6)//'/'/
     1          /swpfilename(1:10)//swpfilename(13:14)//'.ass')
	       n = 0
c               write(6,*)'begin j = 1,num_all'
	       do j = 1, num_all
	          if( abs(rawvr(j,8)) <= maxrv ) then          
	              write(22, '(9f12.3,i12)')(rawvr(j,i),i=1,9),j
	              n = n + 1
	              do i = 1, 9
	                 vr_9(n,i) = rawvr(j,i)
	              enddo
	          endif
	       enddo
c               write(6,*)'end j = 1,num_all'
	       close(22)
	       num_9 = n
C------------------------------------------------------------------------------
C........search vr_9 within SO's bin
c               write(6,*)'beginning i =1,so_num..so_num = ',so_num
	       do i = 1, so_num
	          n = 0
	          do j = 1, num_9
	             dda = abs(vr_9(j,9)-so_azimuth(i))
	             if ( dda <= so_da(i) ) then
c	                ddr = abs(vr_9(j,7)-so_range(i))
                        ddr = abs(rtrack(j)-so_range(i))
	                if ( ddr <= so_dr(i) .and. n < 3499) then
c                     write(6,*)'so_num,j = ',i,j
c		     write(6,*)'vr_9,so_azimuth,dda,so_da = ',
c     1  vr_9(j,9),so_azimuth(i),dda,so_da(i)
c                     write(6,*)'rtrack,so_range = ',
c     1  rtrack(j),so_range(i)
c                        write(6,*)'i,j,vr_9,so_range,ddr,so_dr = ',
c     1  i,j,vr_9(j,7),so_range(i),ddr,so_dr(i)
	                   n = n + 1
c                           write(6,*)'n = ',n
	                   raw_data_bin(i,n,1:9) = vr_9(j,1:9) 
	                endif
	             endif
	          enddo 
	          raw_num_bin(i) = n
                  if(n.gt.nmax)nmax=n
	          if(n >500)write(*,*)i,n,nmax
	       enddo
               write(6,*)'ending with so_num,nmax = ',so_num,nmax
C------------------------------------------------------------------------------
C........raw data qulity control
C........in each bin, kick off the vr whose departure from bin mean is twice large than the bin's spread
	       write(*,*)'======= raw data qulity control ====='
	       do i = 1, so_num
	          if( raw_num_bin(i) > 4 ) then

	              mean = 0.
	              do j = 1, raw_num_bin(i)
	                 mean = mean + raw_data_bin(i, j, 8)
	              enddo
	              mean = mean/raw_num_bin(i) 

	              stdm = 0.
	              do j = 1, raw_num_bin(i)
	                 stdm = stdm + 
     1                   ( raw_data_bin(i, j, 8) - mean )**2.
	              enddo
	              stdm = sqrt(stdm)/(raw_num_bin(i)-1)
	              do j = 1, raw_num_bin(i)
	                 dvr = abs(raw_data_bin(i, j, 8) - mean)/stdrv
	                 if( dvr > stdm ) then
	                     raw_data_bin(i, j, 8) = -888.
	                 endif
	              enddo
	           endif
	        enddo 
C------------------------------------------------------------------------------
C........so bin's spread check.
C........if bin's spread is more twice large than the spread average of all bins', then kick off this so(set raw_data_bin=0)
C........calculate the spread average of all bins
	       write(*,*)'======= so bin spread check  ====='
	       stdm_mean = 0.
	       nbin = 0
	       do i = 1, so_num
	          if( raw_num_bin(i) > 4 ) then
	              mean = 0.
	              n = 0
	              do j = 1, raw_num_bin(i)
	                 if( abs(raw_data_bin(i, j, 8)) <= maxrv ) then
	                     n = n + 1
	                     mean = mean + raw_data_bin(i, j, 8)
	                 endif
	              enddo
	              mean = mean/float(n) 
	              stdm = 0.
	              n = 0
	              do j = 1, raw_num_bin(i)
	                 if( abs(raw_data_bin(i, j, 8)) <= maxrv ) 
     1                        then
	                     n = n + 1
	                     stdm = stdm + 
     1                         ( raw_data_bin(i, j, 8) - mean )**2.
	                 endif
	              enddo
	              if ( n >= 4 ) then
	                 stdm = sqrt(stdm)/float(n-1)   
	                 nbin = nbin + 1
	                 stdm_mean = stdm_mean + stdm
	              endif
	          endif
	       enddo
	       if(nbin > 1) then
	          stdm_mean = stdm_mean/float(nbin)
	       else
	          stdm_mean = -888.
	       endif
C........set raw_num_bin(i) = -999 if the spread of the bin is twice large than stdm_mean
	       do i = 1, so_num
	          if( raw_num_bin(i) > 4 ) then
	              mean = 0.
	              n = 0
	              do j = 1, raw_num_bin(i)
	                 if( abs(raw_data_bin(i, j, 8)) <= maxrv ) then
	                     n = n + 1
	                     mean = mean + raw_data_bin(i, j, 8)
	                 endif
	              enddo
	              mean = mean/float(n)             
	              stdm = 0.
	              n = 0
	              do j = 1, raw_num_bin(i)
	                 if( abs(raw_data_bin(i, j, 8)) <= maxrv ) then
	                     n = n + 1
	                     stdm = stdm + 
     1                               ( raw_data_bin(i, j, 8) - mean )**2.
	                 endif
	              enddo
	              if ( n >= 4 ) then
	                 stdm = sqrt(stdm)/float(n-1)
	              else
	                 stdm = -999
	              endif
	              if (abs(stdm)-stdm_mean*stdrv > 0. ) then
c                       write(6,*)'raw_num_bin, vr spread remove at ',
c     1                   raw_num_bin(i),i
	                 raw_num_bin(i) = -999
	              endif
	           endif
	        enddo 
C------------------------------------------------------------------------------
C........average
	       write(*,*)'======= so bin average  ====='
	       do i = 1, so_num
	          if( raw_num_bin(i) >= 4 ) then
C...............search for the closet data
	              n = iclose
	              if( raw_num_bin(i) <= iclose ) n = raw_num_bin(i)
	              close_rv(1:iclose, 1:9)=-888.
	              close_dis(1:iclose) = 999.
	              do j = 1, n  
	                 close_rv(j,1:9) = raw_data_bin(i, j, 1:9)
	                 alpha = abs(raw_data_bin(i, j, 9) - 
     1                           so_azimuth(i))*3.1415926/180.
c	                 x = raw_data_bin(i, j, 7)*cos(alpha) 
     1                       - so_range(i)
c	                 y = raw_data_bin(i, j, 7)*sin(alpha)
                         x = rtrack(j)*cos(alpha) - so_range(i)
	                 y = rtrack(j)*sin(alpha)
	                 close_dis(j) = sqrt( x*x + y*y )  
	              enddo
	              if( raw_num_bin(i) > iclose )then
	                  do j = iclose+1, raw_num_bin(i)
	                     alpha = abs(raw_data_bin(i, j, 9) - 
     1                               so_azimuth(i))*3.1415926/180.
	                     x = raw_data_bin(i, j, 7)*cos(alpha) - 
     1                             so_range(i)
c	                     y = raw_data_bin(i, j, 7)*sin(alpha)
	                     x = rtrack(j)*cos(alpha) - so_range(i)
	                     y = rtrack(j)*sin(alpha)
	                     dis = sqrt( x*x + y*y )  
	                     n = maxloc(close_dis(1:iclose),dim=1)
	                     if( dis < close_dis(n)) then
	                         close_rv(n, 1:9) = 
     1                              raw_data_bin(i, j, 1:9)
	                         close_dis(n) = dis
	                     endif
	                  enddo
	               endif
C...............average
	              n = iclose
	              if( raw_num_bin(i) <= iclose ) n = raw_num_bin(i)
	              so_vr(i,8) = 0.
	              nr = 0
	              do j = 1, n
c                         write(6,*)'raw_data_bin,maxrv = ',
c     1                    raw_data_bin(i,j,8),maxrv
	                 if( abs(raw_data_bin(i,j,8)) <= maxrv ) then
	                     nr = nr + 1
	                     so_vr(i,8) = so_vr(i,8) + 
     1                                    raw_data_bin(i,j,8)
	                 endif
c                         write(6,*)'nr = ',nr
	              enddo
	              if( nr >= 4 ) then
	                  so_vr(i,8) = so_vr(i,8)/float(nr)
	              else
	                  so_vr(i,8) = -888.
	              endif
	              j = minloc(close_dis(1:n),dim=1)
	              so_vr(i,1:7) = raw_data_bin(i,j,1:7)
	              so_vr(i,9) = raw_data_bin(i,j,9)
c                      write(6,*)'a raw bin num, i = ',raw_num_bin(i),i
	          else
c                      write(6,*)'raw bin num, i = ',raw_num_bin(i),i
	              so_vr(i,1:9) = -888.
	          endif
	       enddo 
C........output SO
	       open(23, file='../'//swpfilename(1:6)//'/'/
     1             /swpfilename(1:10)//swpfilename(13:14)//'.so')
	       do i = 1, so_num
	          if( abs(so_vr(i,8)) <= maxrv ) then
	             write(23, '(i4,4i2.2,8f12.3)')year, month, 
     1                 day, hour, minute, so_vr(i,2:9)
c                   if(iheighttest(i).eq.1)then
c	              write(6, '(i4,4i2.2,12f12.3,i5)')year, month, 
c     1                  day, hour, minute, so_vr(i,2:9),
c     1                 heighttest(i), so_range(i), so_azimuth(i),
c     1                 min_elv,i
c                       pause
c	 	   endif
	          endif
	       enddo
	       close(23)
	    end do do_forback_sweep_loop
	end do do_minutes_loop
	end
C==============================================================================
	 subroutine datetime(year, month, day, hour, minute, second,
     1    hours48)
	 implicit none
	 integer :: year, month, day, hour, minute, second
	 integer :: mon_day, hours48
	 do_sec_loop : do
	    if( second .lt. 60 .and. second .ge. 0 ) exit
	    if( second .ge. 60 ) then
	        second = second - 60
	        minute = minute + 1
	    else if ( second .lt. 0 ) then
	        second = second + 60
	        minute = minute - 1
	    endif
	 end do do_sec_loop
	 do_min_loop : do
	    if( minute .lt. 60 .and. minute .ge. 0 ) exit
	    if( minute .ge. 60 ) then
	        minute = minute - 60
	        hour   = hour + 1
	    else if ( minute .lt. 0 ) then
	        minute = minute + 60
	        hour   = hour - 1
	    endif
	 end do do_min_loop
         hours48=hour
	 do_hour_loop : do
	    if( hour .lt. 24 .and. hour .ge. 0 ) exit
	    if( hour .ge. 24 ) then
	        hour = hour - 24
	        day  = day  + 1
	    else if ( hour .lt. 0 ) then
	        hour = hour + 24
	        day  = day  - 1
	    endif
	 end do do_hour_loop
	 do_day_loop : do
	    if( hour .lt. 24 .and. hour .ge. 0 ) exit
	    if( hour .ge. 24 ) then
	        hour = hour - 24
	        day  = day  + 1 
	    else if ( hour .lt. 0 ) then
	        hour = hour + 24
	        day  = day  - 1 
	    endif
	 end do do_day_loop
	 mon_day = 31
	 if (month == 4 .or. month == 6 .or. month == 9 .or. 
     1       month == 11) mon_day = 30
	 if (month == 2 .and. mod(year,4) == 0) mon_day = 29
	 if (month == 2 .and. mod(year,4) >  0) mon_day = 28
	 if( day .gt. mon_day ) then
	    month = month + int(day/(mon_day+1))
	    day   = mod(day, mon_day+1)
	 else if ( day .lt. 1 ) then
	    month = month - 1
	    mon_day = 31
	    if (month == 4 .or. month == 6 .or. month == 9 .or. 
     1          month == 11) mon_day = 30
	    if (month == 2 .and. mod(year,4) == 0) mon_day = 29
	    if (month == 2 .and. mod(year,4) >  0) mon_day = 28
	    day = day + mon_day
	 endif
	 if ( month > 12 ) then
	    year = year + month/(12+1)
	    month = mod(month, 12+1)
	 else if ( month < 1 ) then
	    year = year - 1
	    month = month + 12
	 endif
	 end subroutine datetime
C==============================================================================
