# include <stdlib.h>
# include <stdio.h>
# include <string.h>
# include <math.h>
# include <inttypes.h>

# include "iris_structures.h"
void main( int argc, char **argv)
{
# include "TDR_hdr.h"

FILE *fp;

	printf(" System sizes: \n");
	printf("size of char: %d \n",sizeof(char) );
	printf("size of int: %d \n",sizeof(int) );
	printf("size of int short: %d \n",sizeof(int short) );
	printf("size of int long: %d \n",sizeof(int long) );
	printf("size of float: %d \n",sizeof(float) );
	printf("size of double: %d \n",sizeof(double) );
	printf("size of long double: %d \n",sizeof(long double) );
	
	printf(" Size of file struct: %d \n", sizeof( *fp ));
	printf(" Size of ptr to file struct: %d \n", sizeof( fp ));
	printf("===================================== \n");
	
	printf(" IRIS structure sizes: \n");
/* Print out structure sizes to be sure they match IRIS documentation,
 */
	printf("stuff in iris first record: \n");
	printf("size of product configuration: %d\n",
		sizeof( struct product_config) );
	printf("size of product end %d\n",
		sizeof( struct product_end ) );

	printf("stuff in iris second record: \n");
	printf("size of ingest_configuration: %d\n",
		sizeof( struct ingest_configuration) );
	printf("stuff that will appear in dara records: \n");
	printf("size of ingest_data_hdr: %d\n",
		sizeof( struct ingest_data_hdr) );
	printf("size of raw_prod_bhdr: %d\n",
		sizeof( struct raw_prod_bhdr) );
	printf("size of ray_hdr: %d\n",
		sizeof( struct ray_hdr) );
	printf("size of TDR extended hdr: %d\n",
		sizeof( struct TDR_header) );
	

}

